#include <kos32sys.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define WIN_W 500
#define WIN_H 500

#define evReDraw  1
#define evKey     2
#define evButton  3
#define evExit    4
#define evDesktop 5
#define evMouse   6
#define evIPC     7
#define evNetwork 8
#define evDebug   9

void DrawNeatButton(int x, int y, int w, int h, int color, int id) {
	// Define Button
	define_button(x * 65536 + w, y * 65536 + h, (0x50 << 24) | id, 0);
	
	// Black
	draw_line(x, y+h, x+w, y+h, 0x000000);
	draw_line(x+w, y, x+w, y+h, 0x000000);
	
	// White
	draw_line(x, y, x, y+h, 0xFFFFFF);
	draw_line(x, y, x+w, y, 0xFFFFFF);
	
	// Button
	draw_bar(x +1, y +1, w -1, h -1, color);
}

void DrawNeatButtonWithText(int x, int y, int w, int h, int color, int id, char* text) {
	DrawNeatButton(x, y, w, h, color, id);
	
	int tx = ((((-strlen(text))*8)+w)/2)+x;
	int ty = h/2-7+y;

	draw_text_sys(text, tx, ty, strlen(text), 0x90000000);
}

void Button() {
	int id = get_os_button();
	if (id == 1) exit(0);
}

////// SYSCOLORS
struct kolibri_system_colors {
  color_t frame_area;
  color_t grab_bar;
  color_t grab_bar_button;
  color_t grab_button_text;
  color_t grab_text;
  color_t work_area;
  color_t work_button;
  color_t work_button_text;
  color_t work_text;
  color_t work_graph;
};
static inline void get_system_colors(struct kolibri_system_colors *color_table)
{
  __asm__ volatile ("int $0x40"
		    :
		    :"a"(48),"b"(3),"c"(color_table),"d"(40)
		    );
}
struct kolibri_system_colors sys_color_table;
////// SYSCOLORS


void draw_window(){
	BeginDraw(); 
	DrawWindow(100, 100, WIN_W, WIN_H, "Neat Buttons", sys_color_table.work_area, 0x34);
	DrawNeatButtonWithText(10, 10, 100, 50, sys_color_table.work_area, 2, "Hello");
	EndDraw();
}

int main()
{    
    get_system_colors(&sys_color_table);
    draw_window();
    while(1)
    {
		switch(get_os_event())
		{
			case evButton:
				Button();
				break;
		  
			case evKey:
				get_key();
				break;
			 
			case evReDraw:
				draw_window();
				break;
		}
    }
}
